const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const languages = sequelize.define(
    'languages',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

iso_code: {
        type: DataTypes.TEXT,
      
      

      },

is_supported: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  languages.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity













    db.languages.hasMany(db.songs, {
      as: 'songs_vocal_language',
      foreignKey: {
          name: 'vocal_languageId',
      },
      constraints: false,
    });

















//end loop



    db.languages.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.languages.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.languages.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return languages;
};


